<template>
  <div oncontextmenu="return false;" style="width: 100%">
    <template v-if="onlyView">
      <template v-if="src">
        <pdf
          class="view-pdf"
          ref="view-pdf"
          :page="page"
          :src="src"
          @num-pages="pageCount = $event"
          @page-loaded="currentPage = $event"
        />
      </template>
    </template>
    <template v-else>
      <template v-if="src">
        <v-toolbar elevation="1" v-if="isFullscreen" height="45" color="grey">
          <v-toolbar-title>
            {{ archivo.nombre }}
          </v-toolbar-title>
          <v-toolbar-items class="pl-8">
            <template v-if="pageInfo">
              <div class="ma-1">
                Página {{ currentPage }} de {{ pageCount }}
              </div>
              <v-divider vertical></v-divider>
            </template>
            <template v-if="pageable">
              <v-pagination
                v-model="page"
                :total-visible="10"
                :length="pageCount"
              ></v-pagination>
              <v-divider vertical></v-divider>
            </template>
            <template v-if="zoomeable">
              <div class="zoomeable-full">
                <v-slider
                  v-model="zoom"
                  class="align-center"
                  color="white"
                  :max="maxZoom"
                  :min="minZoom"
                  hide-details
                >
                  <template v-slot:prepend>
                    <v-btn icon @click="zoom--"
                      ><v-icon>mdi-magnify-minus-outline</v-icon></v-btn
                    >
                  </template>
                  <template v-slot:append>
                    <v-btn icon @click="zoom++"
                      ><v-icon>mdi-magnify-plus-outline</v-icon></v-btn
                    >
                    <v-text-field
                      v-model.number="zoom"
                      class="mt-0 pt-0"
                      hide-details
                      single-line
                      suffix="%"
                      type="number"
                      style="width: 60px"
                    ></v-text-field>
                  </template>
                </v-slider>
              </div>
              <v-divider vertical></v-divider>
            </template>
            <template v-if="controls">
              <div class="text-center pt-2" style="width: 400px;">
                <v-tooltip bottom>
                  <template v-slot:activator="{ on, attrs }">
                    <v-btn
                      v-bind="attrs"
                      v-on="on"
                      :disabled="zoom <= minZoom"
                      small
                      icon
                      class="ma-1"
                      @click="centerView"
                      ><v-icon>mdi-aspect-ratio</v-icon></v-btn
                    >
                  </template>
                  <span>Restablecer zoom</span>
                </v-tooltip>
                <template v-if="isFullscreen">
                  <v-tooltip bottom>
                    <template v-slot:activator="{ on, attrs }">
                      <v-btn
                        v-bind="attrs"
                        v-on="on"
                        small
                        icon
                        class="ma-1"
                        @click="closeFullScreen"
                        ><v-icon>mdi-arrow-collapse-all</v-icon></v-btn
                      >
                    </template>
                    <span>Salir de pantalla completa</span>
                  </v-tooltip>
                </template>
                <template v-if="!isFullDocView">
                  <v-tooltip bottom>
                    <template v-slot:activator="{ on, attrs }">
                      <v-btn
                        v-bind="attrs"
                        v-on="on"
                        small
                        icon
                        class="ma-1"
                        @click="isFullDocView = true"
                        ><v-icon>mdi-arrow-expand-horizontal</v-icon></v-btn
                      >
                    </template>
                    <span>Maximizar vista</span>
                  </v-tooltip>
                </template>
                <template v-else>
                  <v-tooltip bottom>
                    <template v-slot:activator="{ on, attrs }">
                      <v-btn
                        v-bind="attrs"
                        v-on="on"
                        small
                        icon
                        class="ma-1"
                        @click="isFullDocView = false"
                        ><v-icon>mdi-arrow-expand-vertical</v-icon></v-btn
                      >
                    </template>
                    <span>Centrar vista</span>
                  </v-tooltip>
                </template>
              </div>
            </template>
          </v-toolbar-items>
        </v-toolbar>
        <div v-if="!isFullscreen">
          <v-toolbar height="45">
            <v-toolbar-title>
              {{ archivo.nombre }}
            </v-toolbar-title>
            <v-toolbar-items class="pl-8">
              <template v-if="pageInfo">
                <div class="ma-1">
                  Página {{ currentPage }} de {{ pageCount }}
                </div>
                <v-divider vertical></v-divider>
              </template>
              <template v-if="pageable">
                <v-pagination
                  v-model="page"
                  :total-visible="10"
                  :length="pageCount"
                ></v-pagination>
                <v-divider vertical></v-divider>
              </template>
              <template v-if="zoomeable">
                <div class="zoomeable-full">
                  <v-slider
                    v-model="zoom"
                    class="align-center"
                    color="primary"
                    :max="maxZoom"
                    :min="minZoom"
                    hide-details
                  >
                    <template v-slot:prepend>
                      <v-btn icon @click="zoom--"
                        ><v-icon>mdi-magnify-minus-outline</v-icon></v-btn
                      >
                    </template>
                    <template v-slot:append>
                      <v-btn icon @click="zoom++"
                        ><v-icon>mdi-magnify-plus-outline</v-icon></v-btn
                      >
                      <v-text-field
                        v-model.number="zoom"
                        class="mt-0 pt-0"
                        hide-details
                        single-line
                        suffix="%"
                        type="number"
                        style="width: 60px"
                      ></v-text-field>
                    </template>
                  </v-slider>
                </div>
                <v-divider vertical></v-divider>
              </template>
              <template v-if="controls">
                <div class="text-center pt-2" style="width: 400px;">
                  <v-tooltip bottom>
                    <template v-slot:activator="{ on, attrs }">
                      <v-btn
                        v-bind="attrs"
                        v-on="on"
                        :disabled="zoom <= minZoom"
                        small
                        icon
                        class="ma-1"
                        @click="centerView"
                        ><v-icon>mdi-aspect-ratio</v-icon></v-btn
                      >
                    </template>
                    <span>Restablecer zoom</span>
                  </v-tooltip>
                  <v-tooltip bottom>
                    <template v-slot:activator="{ on, attrs }">
                      <v-btn
                        v-bind="attrs"
                        v-on="on"
                        small
                        icon
                        class="ma-1"
                        @click="fullscreen = true"
                        ><v-icon>mdi-arrow-expand-all</v-icon></v-btn
                      >
                    </template>
                    <span>Pantalla completa</span>
                  </v-tooltip>
                </div>
              </template>
            </v-toolbar-items>
          </v-toolbar>
        </div>
        <v-card class="rounded-0">
          <div
            :class="[
              { 'pdf-container-full': isFullscreen },
              { 'pdf-container': !isFullscreen },
            ]"
          >
            <v-card class="rounded-0" ref="cardDocument" v-resize="onResize">
              <div
                ref="document"
                class="document"
                :style="'height : calc(' + cardDocumentHeigth + 'px - 57px)'"
              >
                <template v-if="isFullscreen">
                  <div
                    :class="[
                      { 'zoom-full': isFullDocView },
                      { 'zoom-center': !isFullDocView },
                    ]"
                    :style="'width:' + zoom + '%;'"
                  >
                    <div class="wrapper">
                      <pdf
                        v-for="i in pageCount"
                        ref="view-pdf"
                        :key="i"
                        :src="src"
                        :page="i"
                        @page-loaded="currentPage = $event"
                        class="mt-9"
                        style="height: 100%"
                      ></pdf>
                    </div>
                  </div>
                </template>
                <template v-else>
                  <div class="zoom" :style="'width:' + zoom + '%;'">
                    <pdf
                      class="view-pdf"
                      ref="view-pdf"
                      :page="page"
                      :src="src"
                      @num-pages="pageCount = $event"
                      @page-loaded="currentPage = $event"
                    />
                  </div>
                </template>
              </div>
            </v-card>
          </div>
        </v-card>
      </template>
    </template>
    <template>
      <v-dialog
        v-model="fullscreen"
        fullscreen
        :overlay-opacity="1"
        transition="dialog-bottom-transition"
      >
        <v-card class="rounded-0">
          <Component-FolioVisorArchivo
            :is-fullscreen="true"
            :pageable="false"
            :closeFullScreen="closeFullScreenFn"
            :archivo="archivo"
            :staticSrc="src"
          />
        </v-card>
      </v-dialog>
    </template>
  </div>
</template>
<style scoped>
.wrapper {
  -webkit-overflow-scrolling: touch;
  -moz-overflow-scrolling: touch;
  -ms-overflow-scrolling: touch;
  overflow-scrolling: touch;
}
.btn-right {
  position: relative;
  float: right;
  bottom: 10px;
  right: 5px;
}
.zoomeable {
  padding-left: 40px;
  padding-right: 40px;
}
.zoomeable-full {
  padding-left: 40px;
  padding-right: 40px;
  width: 100%;
  z-index: 1;
  bottom: 40px;
}
.zoom {
  width: 100%;
  padding: 20px;
  padding-left: 40px;
  padding-right: 40px;
  margin: auto;
}
.zoom-center {
  width: 100%;
  padding: 20px;
  padding-left: 20%;
  padding-right: 20%;
  margin: auto;
}
.zoom-full {
  width: 100%;
  padding: 20px;
  padding-left: 10px;
  padding-right: 10px;
}
.pdf-container-full {
  overflow: hidden;
  width: 100%;
  padding-left: 0px;
  padding-right: 0px;
  padding-top: 0px;
}
.pdf-container {
  overflow: hidden;
  padding: 15px;
  width: 100%;
}
.document {
  overflow: auto;
  height: 350px;
  background-color: #e6e6e6;
}
.view-pdf {
  width: 100%;
  height: 100%;
  display: initial !important;
}
</style>
<script>
import pdf from "vue-pdf";
import store from "@/store";
const axios = store.state.axiosApiLocal;
export default {
  name: "Component-FolioVisorArchivo",
  components: {
    pdf,
  },
  props: {
    folio: {
      type: Object,
      required: false,
      default: null,
    },
    archivo: {
      type: Object,
      required: true,
    },
    isFullscreen: {
      type: Boolean,
      required: false,
      default: false,
    },
    closeFullScreen: {
      type: Function,
      required: false,
    },
    pageInfo: {
      type: Boolean,
      required: false,
      default: true,
    },
    pageable: {
      type: Boolean,
      required: false,
      default: true,
    },
    zoomeable: {
      type: Boolean,
      required: false,
      default: true,
    },
    controls: {
      type: Boolean,
      required: false,
      default: true,
    },
    onlyView: {
      type: Boolean,
      required: false,
      default: false,
    },
    staticSrc: {
      type: Object,
      required: false,
      default: null,
    },
  },
  data() {
    return {
      loading: true,
      page: 1,
      currentPage: 0,
      pageCount: 0,
      zoom: 100,
      minZoom: 80,
      maxZoom: 500,
      fullscreen: false,
      cardDocumentHeigth: 0,
      src: null,
      isFullDocView: false,
    };
  },
  watch: {
    currentPage(val, prev) {},
    zoom(val, prev) {},
  },
  methods: {
    onResize(event) {
      if (this.isFullscreen) {
        this.cardDocumentHeigth = window.innerHeight + 11;
      } else {
        this.cardDocumentHeigth = window.innerHeight - 181;
      }
    },
    closeFullScreenFn() {
      this.fullscreen = false;
    },
    zoomOut() {
      this.zoom = this.zoom - 10 || 0;
    },
    zoomIn() {
      this.zoom = this.zoom + 10 || 100;
    },
    centerView() {
      this.zoom = this.minZoom;
      const documentPDF = this.$refs["document"];
      if (documentPDF) {
        documentPDF.scrollTo(0, 0);
      }
    },
    addDragMove() {
      const documentPDF = this.$refs["document"];
      if (documentPDF) {
        documentPDF.style.cursor = "grab";
        let pos = { top: 0, left: 0, x: 0, y: 0 };
        const mouseDownHandler = function(e) {
          documentPDF.style.cursor = "grabbing";
          documentPDF.style.userSelect = "none";
          pos = {
            left: documentPDF.scrollLeft,
            top: documentPDF.scrollTop,
            x: e.clientX,
            y: e.clientY,
          };
          documentPDF.addEventListener("mousemove", mouseMoveHandler);
          documentPDF.addEventListener("mouseup", mouseUpHandler);
        };
        const mouseMoveHandler = function(e) {
          const dx = e.clientX - pos.x;
          const dy = e.clientY - pos.y;
          documentPDF.scrollTop = pos.top - dy;
          documentPDF.scrollLeft = pos.left - dx;
        };
        const mouseUpHandler = function() {
          documentPDF.style.cursor = "grab";
          documentPDF.style.removeProperty("user-select");
          documentPDF.removeEventListener("mousemove", mouseMoveHandler);
          documentPDF.removeEventListener("mouseup", mouseUpHandler);
        };
        documentPDF.addEventListener("mousedown", mouseDownHandler);
      }
    },
    setStaticSrc() {
      this.src = this.staticSrc;
      this.src.promise.then((inPdf) => {
        this.pageCount = inPdf.numPages;
      });
      setTimeout(() => {
        this.addDragMove();
      }, 200);
    },
    getFolioArchivoContenido() {
      const self = this;
      this.loading = true;
      axios(
        "/modelo-negocio/folio-archivos/v1/" +
          this.folio.idFolio +
          "/archivos/" +
          this.archivo.uid +
          "/contenido"
      )
        .then((response) => {
          let data = response.data;
          if (data) {
            let initialDoc = data.resultado.archivo;
            self.src = pdf.createLoadingTask(initialDoc);
            self.src.promise.then((inPdf) => {
              self.pageCount = inPdf.numPages;
            });
          }
        })
        .catch((error) => {
          if (error.response) {
            console.log(error.response.data);
          }
        })
        .finally(() => {
          self.loading = false;
          self.$emit("loaded", true);
          self.addDragMove();
        });
    },
  },
  mounted() {
    if (this.staticSrc) {
      this.setStaticSrc();
    }
  },
  created() {
    if (!this.staticSrc) {
      this.getFolioArchivoContenido();
    }
  },
};
</script>
